CARGO-PKGID(1)

NAME
cargo-pkgid - Print a fully qualified package specification

SYNOPSIS

cargo pkgid [OPTIONS] [SPEC]

DESCRIPTION

Given a SPEC argument, print out the fully qualified package ID specifier for a package or dependency in the current workspace. This command will generate an error if SPEC is ambiguous as to which package it refers to in the dependency graph. If no SPEC is given, then the specifier for the local package is printed.

This command requires that a lockfile is available and dependencies have been fetched.

A package specifier consists of a name, version, and source URL. You are allowed to use partial specifiers to succinctly match a specific package as long as it matches only one package. The format of a SPEC can be one of the following:

Table 1. SPEC Query Format
SPEC Structure | Example SPEC
NAME | bitflags
NAME:VERSION | bitflags:1.0.4
URL |
URL#VERSION |
URL#NAME |
URL#NAME:VERSION |

OPTIONS

  Package Selection

-p SPEC, --package SPEC
    Get the package ID for the given package instead of the current package.

  Display Options

-v, --verbose
    Use verbose output. May be specified twice for "very verbose" output which includes extra output such as dependency warnings and build script output. May also be specified with the term.verbose

-q, --quiet
    No output printed to stdout.

--color WHEN
    Control when colored output is used. Valid values:

        • auto (default): Automatically detect if color support is available on the terminal.

        • always: Always display colors.

        • never: Never display colors.

    May also be specified with the term.color

  Manifest Options

--manifest-path PATH
    Path to the Cargo.toml file. By default, Cargo searches in the current directory or any parent directory for the Cargo.toml file.

--frozen, --locked
    Either of these flags requires that the Cargo.lock file is up-to-date. If the lock file is missing, or it needs to be updated, Cargo will exit with an error. The --frozen flag also prevents Cargo from attempting to access the network to determine if it is out-of-date.

    These may be used in environments where you want to assert that the Cargo.lock file is up-to-date (such as a CI build) or want to avoid network access.

  Common Options

-h, --help
    Prints help information.

-Z FLAG...
    Unstable (nightly-only) flags to Cargo. Run cargo -Z help for details.

ENVIRONMENT

See for details on environment variables that Cargo reads.

EXIT STATUS

0
    Cargo succeeded.

101
    Cargo failed to complete.

EXAMPLES

    1. Retrieve package specification for foo package:

        cargo pkgid foo

    2. Retrieve package specification for version 1.0.0 of foo:

        cargo pkgid foo:1.0.0

    3. Retrieve package specification for foo from crates.io:

        cargo pkgid https://github.com/rust-lang/crates.io-index#foo

SEE ALSO

cargo(1), cargo-generate-lockfile(1), cargo-metadata(1)